#ifndef __IMG_TXT_H__
#define __IMG_TXT_H__ 

#include <stdio.h>
#include <gtk/gtk.h>
#include <sstream>
#include "../include/gray_buffer.h"
// Convertit l'image 'img' en texte ASCII-Art en se servant de 'palette' comme reference d'ordre de caractere.
// Les caracteres du texte sont choisis dans 'palette', le rang dans la palette est determine par le niveau
// de gris du pixel correspondant.
// 'palette' est donc ordonnee du caractere le plus fonce au plus clair et est compose de 256 caracteres.

// Le texte est retourne sous forme d'image Pixbuf, les caracteres sont copies a partir de l'image 'police'.
// les 256 caracteres sont les uns derieres les autres du 0 au 255 (odre ASCII, le 'A' est le n65, le 'B' le 66...).
GdkPixbuf * IMG_TXT_Pixbuf        (gray_buffer &img, gchar *palette,
                                                         GdkPixbuf * police);

// utilise par IMG_TXT_txt et IMG_TXT_htm pour le 'corps' du texte, la chaine de caracteres 
// 'debut_de_fichier' est copie au debut du fichier
// 'fin_de_ligne' est copie a chaque fin de ligne
// 'fin_de_fichier' est copie a la fin du fichier
bool  IMG_TXT_fichier_texte (gray_buffer &img, gchar *palette,
                             const gchar *nom_de_fichier,
                             const gchar *debut_de_fichier,
                             const gchar *fin_de_ligne,
                             const gchar *fin_de_fichier);


// Fonction diverses : 'private' en quelque sorte

guint8 * getpixel(GdkPixbuf * pixbuf, int &x, int &y);

guint8 rang_caract(guint8 car, int gamma, int contraste, int nb_caract, int taille_palette_orig);

char chercher_caract(char *chaine, char &caract);

void reordonner_palette(gchar *Palette, gchar *Palette_de_reference);

#endif

