#ifndef __FENETRE_IMG_TXT_H__
#define __FENETRE_IMG_TXT_H__ 


#include <sstream>
#include <fstream>
#include <gtk/gtk.h>
#include <glade/glade.h>
#include "../include/gray_buffer.h"
#include "../include/IMG-TXT.h"


#ifdef G_OS_WIN32
#include <windows.h> 
#endif


const int Format_A[8][2] = {{594,840},
                            {420,594},
                            {297,420},
                            {210,297},
                            {148,210},
                            {105,148},
                            {074,105},
                            {052,074}};
          
class fenetre_img_txt
{
     public:
         
       fenetre_img_txt();
       fenetre_img_txt(const char *filename_xml);
       void fenetre_img_txt_init(const char *filename_xml);
       ~fenetre_img_txt();
      
     private:
          
   // Mthodes
          
      #define DECLARER_CALLBACK_FIT(METH) void METH();static void exec_##METH(fenetre_img_txt * th){ th->METH();};
      
      // fit_bouttons_zoom.cpp
          DECLARER_CALLBACK_FIT( zoom_arriere );
          DECLARER_CALLBACK_FIT( zoom_avant );
          DECLARER_CALLBACK_FIT( zoom_ajuster );
          DECLARER_CALLBACK_FIT( zoom_normal );
          DECLARER_CALLBACK_FIT( zoom_25 );
          DECLARER_CALLBACK_FIT( zoom_50 );
          DECLARER_CALLBACK_FIT( zoom_75 );
          DECLARER_CALLBACK_FIT( zoom_100 );
      
      // fit_changements.cpp
          DECLARER_CALLBACK_FIT( on_combobox_palette_changed );
          DECLARER_CALLBACK_FIT( on_Entry_palette_changed );
          DECLARER_CALLBACK_FIT( changer_resolution );
          DECLARER_CALLBACK_FIT( on_image_ecran_size_allocate );
          DECLARER_CALLBACK_FIT( on_texte_ecran_size_allocate );
          DECLARER_CALLBACK_FIT( changement_zoom );
          DECLARER_CALLBACK_FIT( changement_parametre_texte );
          DECLARER_CALLBACK_FIT( changement_largeur_texte );
          DECLARER_CALLBACK_FIT( on_menu_taille_predef_changed );
          DECLARER_CALLBACK_FIT( on_onglets_switch_page );
          DECLARER_CALLBACK_FIT( changement_nb_couleur );
          
      
      // fit_fenetres.cpp
          DECLARER_CALLBACK_FIT( ouvrir );
          DECLARER_CALLBACK_FIT( on_annuler_ouvrir );
          DECLARER_CALLBACK_FIT( on_valider_ouvrir );
          DECLARER_CALLBACK_FIT( on_annuler_enregistrer );
          DECLARER_CALLBACK_FIT( on_valider_enregistrer );
          DECLARER_CALLBACK_FIT( ouvrir_site );
          DECLARER_CALLBACK_FIT( ouvrir_aide );
          DECLARER_CALLBACK_FIT( ouvrir_a_propos );
          DECLARER_CALLBACK_FIT( ouvrir_resolution );
          DECLARER_CALLBACK_FIT( ouvrir_fenetre_palette );
          DECLARER_CALLBACK_FIT( masquer_a_propos );
          DECLARER_CALLBACK_FIT( masquer_palette );
          DECLARER_CALLBACK_FIT( masquer_aide );
          DECLARER_CALLBACK_FIT( masquer_resolution );
          
      // fit_initialisation.cpp
          DECLARER_CALLBACK_FIT( initiliser_widget );
          DECLARER_CALLBACK_FIT( connecter_signaux );
          DECLARER_CALLBACK_FIT( initiliser_palettes );
          
      // fit_fichiers.cpp
          DECLARER_CALLBACK_FIT( enregistrer );
          DECLARER_CALLBACK_FIT( enregistrer_sous );
          DECLARER_CALLBACK_FIT( nom_automatique );
          
          bool enregistrer_txt(const gchar * nom_de_fichier);
          bool enregistrer_htm(const gchar * nom_de_fichier);
          void enregistrer_jpg(const gchar * nom_de_fichier);
          void enregistrer_png(const gchar * nom_de_fichier);
          void ouvrir_fichier_creer();
          
          public:
          void ouvrir_fichier(const char* filename);
          private:
      
      // fit_methodes_divers.cpp
          DECLARER_CALLBACK_FIT( quitter );
          int obtenir_zoom();
          int obtenir_gamma();
          int obtenir_contraste();
          int obtenir_nb_caract();
          int obtenir_largeur_caract();
          int largeur_caract_taille_predef(int A);
          void recreer_palette_transformee();
          void afficher_taille();
          
          DECLARER_CALLBACK_FIT( image_glisser );
          DECLARER_CALLBACK_FIT( image_presser );
          DECLARER_CALLBACK_FIT( image_relacher );
          DECLARER_CALLBACK_FIT( texte_glisser );
          DECLARER_CALLBACK_FIT( texte_presser );
          DECLARER_CALLBACK_FIT( texte_relacher );
          
          DECLARER_CALLBACK_FIT( changement_case_apercu );
          DECLARER_CALLBACK_FIT( update_preview );
          
      
      // fit_recreer_images.cpp
          void recreer_pb_image(const char *filename);
          void recreer_image_ecran();
          void recreer_pb_texte();
          void recreer_texte_ecran();
          void recreer_image_gray();
            
            
   //Constantes
        //  static const double zoom_min = 1;
       //   static const double zoom_max = 200;
       //   static const double zoom_pas = 10;

#define zoom_min 1
#define zoom_max 200
#define zoom_pas 10

          static const gchar BMP = 0;
          static const gchar TXT = 1;
          static const gchar HTM = 2;
          const gchar *palette_V4;
          const gchar *palette_V3;
          const gchar *palette_defaut_entiere;
          const gchar *palette_reference_defaut;
          int larg_caract;
          int haut_caract;
          
   // Variables
          GladeXML * xml;
          gchar * nom_fichier_sortie;
          gint extention_fichier_sortie;
          gray_buffer image_gray;
          GdkPixbuf * pb_image;
          GdkPixbuf * pb_texte;
          GdkPixbuf * police;
          gchar palette_reference[257];
          gchar palette[257];
          gchar palette_transformee[257];
          int zoom_switch;
          bool switch_page;
          bool switch_taille;
          double pixel_par_mm;
          
          int coord_x;
          int coord_y;
          
          
      
   // Widgets
          GtkWindow            * fenetre_principale;
          GtkWindow            * fenetre_ouvrir;
          GtkWindow            * fenetre_enregistrer_sous;
          GtkWindow            * fenetre_a_propos;
          GtkWindow            * fenetre_palette;
          GtkWindow            * fenetre_resolution;
          GtkFileChooserWidget * filechooser_ouvrir;
          GtkFileChooserWidget * filechooser_enregistrer;
          GtkImage             * image_ecran;
          GtkImage             * texte_ecran;
          GtkCheckMenuItem     * option_ouvrir_auto;
          GtkCheckMenuItem     * option_actualiser;
          GtkCheckMenuItem     * ne_pas_fermer_ouvrir;
          GtkCheckMenuItem     * diffusion_d_erreur;
          GtkHScale            * barre_zoom;
          GtkHScale            * barre_gamma;
          GtkHScale            * barre_nb_caract;
          GtkHScale            * barre_contraste;
          GtkComboBox          * menu_taille_predef;
          GtkComboBox          * combobox_extension;
          GtkComboBox          * combobox_palette;
          GtkSpinButton        * reglage_largeur_caract;
          GtkSpinButton        * spinbutton_resolution;
          GtkNotebook          * onglets;
          GtkEntry             * entry_enregistrer;
          GtkEntry             * entry_palette_perso;
          GtkStatusbar         * statusbar1;
          GtkScrolledWindow    * scrolledwindow_image;
          GtkScrolledWindow    * scrolledwindow_texte;
          GtkViewport          * viewport_image;
          GtkViewport          * viewport_texte;
          GtkImage             * preview;
          GtkCheckButton       * case_apercu;
          GtkCheckMenuItem     * nom_auto;
};

#endif

