#include "../include/IMG-TXT.h"


//<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
GdkPixbuf * IMG_TXT_Pixbuf (gray_buffer &img, gchar *palette, GdkPixbuf * police)
{
      int larg_caract = gdk_pixbuf_get_width(police)/256;
      int haut_caract = gdk_pixbuf_get_height(police);
      int larg_img = img.get_width();
      int haut_img = img.get_height();
      guint8 * buffer = img.get_pixels();
      
      GdkPixbuf * txt =
      gdk_pixbuf_new  (GDK_COLORSPACE_RGB, 0, 8, larg_img*larg_caract,
                                                     haut_img*haut_caract);
     
      if(txt != (GdkPixbuf *)NULL)
      for(int j = 0; j < haut_img; j++)
         for(int i = 0; i < larg_img; i++)
      gdk_pixbuf_copy_area (police,
      larg_caract * guint8(palette[ buffer[i+j*larg_img] ]), 
      0, 
      larg_caract, haut_caract, txt, i*larg_caract, j*haut_caract);
      
      
      
      return txt;
}
//>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>








































//#include <iostream>
//using namespace std;




//<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
bool IMG_TXT_fichier_texte (gray_buffer &img, gchar * palette, const gchar * nom_de_fichier,
                                                        const gchar *debut_de_fichier,
                                                        const gchar *fin_de_ligne,
                                                        const gchar *fin_de_fichier)
{
 //    cout << "IMG_TXT_fichier_texte debut" << endl;
     
     
     if( (debut_de_fichier == NULL) || (fin_de_ligne == NULL) || (fin_de_fichier == NULL))
        return 0;
        
      int larg_img = img.get_width();
      int haut_img = img.get_height();
      guint8 * image = img.get_pixels();
      int taille_fin_de_ligne = strlen(fin_de_ligne);
      long unsigned int taille_du_txt = larg_img * haut_img + haut_img*taille_fin_de_ligne;
      gchar * txt = new gchar[taille_du_txt];
      gchar * curseur = txt;
     
      for(int j = 0; j < haut_img; j++)
         {
            for(int i = 0; i < larg_img; i++)
            {
                 *curseur = palette[ image[i+j*larg_img] ];
                 curseur++;
            }
            strcpy(curseur,fin_de_ligne);
            curseur += taille_fin_de_ligne;
         }
         
 //    cout << "fopen..." << endl;
     
     FILE * F = fopen(nom_de_fichier, "w");
     
     
     if( F == NULL )
        {
  //   cout << "F == NULL" << endl;
              delete[] txt;
              return 0;
        }
        
 //    cout << "fwrite" << endl;
      fwrite( debut_de_fichier, strlen(debut_de_fichier), 1, F);
      fwrite( txt, taille_du_txt, 1 , F);
      fwrite( fin_de_fichier, strlen(fin_de_fichier), 1, F);

 //    cout << "fclose" << endl;
      fclose(F);
      
      delete[] txt;
      
  //   cout << "IMG_TXT_fichier_texte fin" << endl << endl;
      return 1;
}
//>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>



//<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
guint8 * getpixel(GdkPixbuf * pixbuf, int &x, int &y)
{
      return gdk_pixbuf_get_pixels(pixbuf) + gdk_pixbuf_get_rowstride(pixbuf) * y + gdk_pixbuf_get_n_channels(pixbuf) * x;
}
//>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

const double Pi = 3.1415926535897932384626433832795;

int appliquer_contraste(int coul, int contraste)
{
       return int(round( 127.5 + (coul - 127.5)* tan(Pi/4-Pi/4*contraste/255)));
}

int appliquer_gamma(int coul, int gamma)
{
       return coul - gamma;
}


int appliquer_nb_caract(int coul, int nb_caract)
{
       return int(round(
                          round(coul * nb_caract / 255) *255 / nb_caract) );
}



//<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
guint8 rang_caract(guint8 coul, int gamma, int contraste, int nb_caract, int taille_palette_orig)
{
       int caract = coul;
       caract = appliquer_gamma( caract, gamma);
       caract = appliquer_contraste( caract, contraste);
  //     caract = appliquer_nb_caract( caract, nb_caract * taille_palette_orig / 256);
       caract = caract * (taille_palette_orig-1) / 255;
       
       if(caract < 0)                        return 0;
       if(caract > taille_palette_orig-1)    return taille_palette_orig-1;
       return caract;
}
//>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>




/*
//<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
guint8 rang_caract(guint8 car, int gamma, int contraste,int nb_caract, int taille_palette_orig)
{
       int caract = car - gamma;
       
       if(caract < 0)
          return 0;
          
       if(caract > 255)
          return taille_palette_orig-1;
          
       return guint8(
       round(caract * nb_caract / 256) *taille_palette_orig / nb_caract);
       
       caract = int(round(
       round(caract * nb_caract / 256 +1) *taille_palette_orig / nb_caract));
       
       if(caract > taille_palette_orig-1)
          return taille_palette_orig-1;
          
       return caract;
}
//>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
*/


//<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
char chercher_caract(char *chaine, char &caract)
{
  int taille_chaine = strlen(chaine);
  if (taille_chaine > 255) taille_chaine = 255;
  
  for(int i = 0; i < taille_chaine; i++)        
    if (chaine[i] == caract)
      return (char)i; 
  return -1;
}
//>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>



//<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
void reordonner_palette(gchar *Palette, gchar *Palette_de_reference)
{
  gchar Palette_temp[256][2];
  
  gchar temp[2];
  
  int taille_chaine = strlen(Palette);
  
  
  for (int i = 0; i < taille_chaine; i++)
    {
      Palette_temp[i][0] = Palette[i];
      Palette_temp[i][1] = chercher_caract(Palette_de_reference, Palette[i]);
    }    
  
  
  for (int i = 0; i < taille_chaine; i++)
    for (int j = i; j > 0; j--)
      {
	if (guint8(Palette_temp[j][1]) < guint8(Palette_temp[j-1][1]))
	  {
	    temp[0] = Palette_temp[j-1][0];
	    temp[1] = Palette_temp[j-1][1];
	    
	    Palette_temp[j-1][0] = Palette_temp[j][0];
	    Palette_temp[j-1][1] = Palette_temp[j][1];
	    
	    Palette_temp[j][0] = temp[0];
	    Palette_temp[j][1] = temp[1];
	  }
	else 
	  break;
	
      }    
  
  int j = 0;
  
  for (int i = 0; i < taille_chaine; i++)
    if (Palette_temp[i][1] != -1)
      {
	Palette[j] = Palette_temp[i][0];  
	j++;
      }    
  Palette[j] = 0;
}
//>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

