////////////////////////////////////////////////////////////////////////////////
//  Name      : IMG-TXT 5 GTK+                                                //
//  Copyright : GNU GPL                                                       //
//  Author    : Jeremy SOULARY                                                //
//                                                                            //
// dependances principales : gtk, gdk, libglade, ...                          //
//                                                                            //
// option de compilation sous Win32 :                                         //
//       -mms-bitfields -lgtk-win32-2.0 -latk-1.0 -lgdk_pixbuf-2.0            //
//       -lgobject-2.0 -lglib-2.0 -llibglade-2.0                              //
//   et peut-etre aussi :                                                     //
//       -I"C:/GTK/INCLUDE"  -I"C:/GTK/INCLUDE/GTK-2.0"                       //
//       -I"C:/GTK/INCLUDE/GLIB-2.0"  -I"C:/GTK/INCLUDE/PANGO-1.0"            //
//       -I"C:/GTK/INCLUDE/ATK-1.0"  -I"C:/GTK/INCLUDE/GTKGLEXT-1.0"          //
//       -I"C:/GTK/LIB/GTK-2.0/INCLUDE"  -I"C:/GTK/LIB/GLIB-2.0/INCLUDE"      //
//       -I"C:/GTK/LIB/GTKGLEXT-1.0/INCLUDE"  -I"C:/GTK/INCLUDE/LIBGLADE-2.0" //
//       -I"C:/GTK/INCLUDE/LIBXML2"                                           //
//                                                                            //
// option de compilation sous Linux :                                         //
//       -L"/usr/lib/" -lgtk-x11-2.0 -lglade-2.0                              //
//   et peut-etre aussi :                                                     //
//       -I"/usr/include/gtk-2.0" -I"/usr/include/glib-2.0"                   //
//       -I"/usr/include/pango-1.0" -I"/usr/include/atk-1.0"                  //
//       -I"/usr/lib/gtk-2.0/include" -I"/usr/lib/glib-2.0/include"           //
//       -I"/usr/include/libglade-2.0" -I"/usr/include/cairo"                 //
////////////////////////////////////////////////////////////////////////////////

#include <limits.h>
#include <unistd.h>
#include <string.h>
//#include "../config.h"
#include "../include/config.h"

std::string data_dir;
std::string data_dir_gla;
std::string data_dir_pol;

#include <stdio.h>

size_t get_executable_path (char* buffer, size_t len)
{
 char* path_end;
 if (readlink ("/proc/self/exe", buffer, len) <= 0)
  return -1;
 path_end = strrchr (buffer, '/');
 if (path_end == NULL)
  return -1;
 ++path_end;
 *path_end = '\0';
 return (size_t) (path_end - buffer);
}

int config ()
{
 char path[PATH_MAX];
 if(get_executable_path (path, sizeof (path)) < 0)
 {
	  printf ("repertoire d instalation introuvable\n");
	 exit(0);
  }
// printf ("repertoire d instalation : %s\n", path);
  
	std::string dir = path;
	 data_dir = dir + "../data"; // run from source dir
          if (access(data_dir.c_str(), F_OK) != 0)
            {
              data_dir = dir + "../share/imgtxt"; // run from PATH
              if (access(data_dir.c_str(), F_OK) != 0) 
                { 
	                 printf ("repertoire d instalation introuvable\n");
	                 exit(0);
                }
            }
// printf ("repertoire data : %s\n", data_dir.c_str());
			
	data_dir_gla = data_dir+"/glade/imgtxt.glade";
    data_dir_pol = data_dir+"/terminal_6_police.bmp";
			
	return 0;
}










#include "../include/fenetre_img_txt.h"
#include "../include/config.h"

int main(int argc, char *argv[])
{
      config();
	  // initialisation de Gtk
      gtk_init (&argc, &argv);
      
      // initialisation de la fenetre
      fenetre_img_txt fenetre_img_txt(data_dir_gla.c_str());
      
      // boucle d'evenements
      gtk_main ();
      
      return 0;
}
